<?php
class feature_posts_widget extends WP_Widget {
    /** constructor */
    function feature_posts_widget() {
        parent::WP_Widget( false, $name = __("(Obox) Featured Posts Widget","ocmx"), array( "description" => __("Display 4 featured posts with images or videos in a tabbed slider.","ocmx") ) );	
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {		
        // Turn $args array into variables.
		extract( $args );
		
		// Turn $instance array into variables
		$instance_defaults = array ('post_thumb' => 1, 'post_category' => '0', 'show_excerpts' => true, "show_small_excerpts" => false, "show_continue" => true);
		$instance_args = wp_parse_args( $instance, $instance_defaults );
		extract( $instance_args, EXTR_SKIP );
		
		if(isset($instance["post_category"]))
			$use_category = $instance["post_category"];
		if(isset($instance["post_thumb"]))
			$post_thumb = $instance["post_thumb"];
		if( $post_thumb == "true" ):
			$post_thumb = 1;
		else :
			$post_thumb = 0;		
		endif;
		
		if(isset($instance["read_more"]) && $instance["read_more"] !="") :
			$readmoretext = $instance["read_more"];
		else :
	        $readmoretext = _(__("Read More","ocmx"));
		endif;
		
		$args = array(
			'posts_per_page' => 4,
			'post_not__in'  => get_option( 'sticky_posts' ),
			'ignore_sticky_posts' => 1,
			'tax_query' => array(
					array(
						"taxonomy" => 'category',
						"field" => "slug",
						"terms" => $use_category
					)
				)
		);

		//Set the post Aguments and Query accordingly
		$count = 1;
		$ocmx_featured = new WP_Query($args);

?>      
   	<div class="feature clearfix">
    	<!--Begin Large Slide -->
        <div class="left-column">
        	<?php while ( $ocmx_featured->have_posts() ) : $ocmx_featured->the_post();
				global $post;		
                $this_post = get_post( $post->ID );
				$link = get_permalink( $this_post->ID ); 
				$args  = array( 'postid' => $ocmx_featured->post->ID, 'width' => 520, 'height' => 300, 'hide_href' => false, 'exclude_video' => $post_thumb, 'resizer' => '520x300' );
				$image = get_obox_media( $args );
			?>
                <div <?php if( $count !== 1 ): ?>style="display: none;"<?php endif; ?> id="feature-copy-<?php echo $count; ?>">
                	<div class="post">
                    	<!--Show the Featured Image or Video -->
						<?php echo $image; ?>
                        <!--Show the Title -->
                        <h2 class="post-title"><a href="<?php echo $link; ?>"><?php the_title(); ?></a></h2>
                        <!--Show the Excerpt -->
                        <?php if($show_excerpts == "on" ) { 
								the_excerpt(); 
						} ?>                        
                    </div>
                    <?php if( get_option("ocmx_post_meta") !="off") : ?>
                        <ul class="meta">
                            <?php if( get_option("ocmx_meta_date") != "false" ): ?> 
                                <li><?php the_time( get_option('date_format') ); ?></li>
                            <?php endif; ?>
                            <?php if( comments_open( $post->ID ) && get_option("ocmx_meta_comments") != "false" ): ?> 
                                <li><a href="<?php echo $link; ?>#comments"><?php _e($this_post->comment_count." Comments"); ?></a></li>
                            <?php endif; ?>
                            <?php if( get_option("ocmx_meta_author") != "false" ): ?>
                                <li><?php _e("By"); ?> <a href="<?php echo $link; ?>"><?php the_author(); ?></a></li>
                            <?php endif; ?>
                        </ul>
                    <?php endif; ?>
                    <!--Show Read More Link -->
                    <?php if(isset($show_continue) && $show_continue == "on" ) : ?>
		            	<a href="<?php echo $link; ?>" class="action-link"><?php echo $readmoretext; ?></a>
                    <?php endif; ?>
                </div>
			<?php 
				$count++;
			endwhile; ?>
        </div>
        <!--Begin Thumbnail tabs -->
        <ul class="right-column">
        	<?php  $count=1;
				while ( $ocmx_featured->have_posts()) : $ocmx_featured->the_post(); 		
                $this_post = get_post( $post->ID );
				$args  = array( 'postid' => $ocmx_featured->post->ID, 'width' => 100, 'height' => 80, 'hide_href' => true, 'imglink' => false, 'exclude_video' => true, 'resizer' => '100x80' );
				$image = get_obox_media( $args );
				$link = get_permalink( $this_post->ID ); ?>
                <li <?php if( $count == 1 ): ?>class="active"<?php endif; ?> id="feature-li-<?php echo $count; ?>">
                    <a href="#" class="clearfix" id="feature-href-<?php echo $count; ?>"> 
						<!--Show the Featured Post Thumbnail -->
             			<?php echo $image; ?>
                        <!--Show the Title -->
						<span class="title"><?php the_title(); ?></span>
						<!--Show the Excerpt -->
						<span class="splurb">
							<?php $title_len = strlen( $this_post->post_title );
							// Excerpts on/off
		                    	if($show_small_excerpts == "on" ) {
									if( $title_len > 22 ) 
										{ $content_len  = 90; }
									else
										{ $content_len  = 120; }
									echo substr(strip_tags($this_post->post_excerpt), 0, $content_len);
									echo "...";
							} ?>                        
                            </span>
                    </a>
                </li>
			<?php 
				$count++;
			endwhile; ?>
        </ul>
    </div>
<?php
    }

    /** @see WP_Widget::update */
    function update( $new_instance, $old_instance ) {
        return $new_instance;
    }

    /** @see WP_Widget::form */
    function form( $instance ) {
		// Turn $instance array into variables
		$instance_defaults = array ('post_thumb' => 1, 'post_category' => '0');
		$instance_args = wp_parse_args( $instance, $instance_defaults );
		extract( $instance_args, EXTR_SKIP );

?>
    <p><label for="<?php echo $this->get_field_id('post_category'); ?>">Posts Category</label>
           <select size="1" class="widefat" id="<?php echo $this->get_field_id("post_category"); ?>" name="<?php echo $this->get_field_name("post_category"); ?>">
                <option <?php if( $post_category == 0 ){ echo "selected=\"selected\""; } ?> value="0">All</option>
                <?php
                        $category_args = array('hide_empty' => false);
                        $option_loop = get_categories($category_args);
                        foreach($option_loop as $option_label => $value)
                            { 	
                                // Set the $value and $label for the options
                                $use_value =  $value->slug;
                                $label =  $value->cat_name;
                                //If this option == the value we set above, select it
                                if($use_value == $instance["post_category"])
                                    {$selected = " selected='selected' ";}
                                else
                                    {$selected = " ";}
                ?>
                                <option <?php echo $selected; ?> value="<?php echo $use_value; ?>"><?php echo $label; ?></option>
                <?php 
                            }
                ?>
            </select>
        </p>
     <p>
		<label for="<?php echo $this->get_field_id('post_thumb'); ?>">Thumbnails</label>
		<select size="1" class="widefat" id="<?php echo $this->get_field_id('post_thumb'); ?>" name="<?php echo $this->get_field_name('post_thumb'); ?>">
        	<option <?php if( $post_thumb == "true" ) : ?>selected="selected"<?php endif; ?> value="true">Post Feature Image</option>
        	<option <?php if( $post_thumb == "false" ) : ?>selected="selected"<?php endif; ?> value="false">Videos</option>
		</select>
	</p>
    <p>
        <label for="<?php echo $this->get_field_id('show_excerpts'); ?>">
        	<input type="checkbox" <?php if(isset($show_excerpts) && $show_excerpts == "on" ) : ?>checked="checked"<?php endif; ?> id="<?php echo $this->get_field_id('show_excerpts'); ?>" name="<?php echo $this->get_field_name('show_excerpts'); ?>">
			Show Excerpts in Main Post
        </label>
	</p>
    <p>
        <label for="<?php echo $this->get_field_id('show_small_excerpts'); ?>">
        	<input type="checkbox" <?php if(isset($show_small_excerpts) && $show_small_excerpts == "on" ) : ?>checked="checked"<?php endif; ?> id="<?php echo $this->get_field_id('show_small_excerpts'); ?>" name="<?php echo $this->get_field_name('show_small_excerpts'); ?>">
			Show Excerpts in Tabs
        </label>
	</p>
    <p>
        <label for="<?php echo $this->get_field_id('show_continue'); ?>">
        	<input type="checkbox" <?php if(isset($show_continue) && $show_continue == "on") : ?>checked="checked"<?php endif; ?> id="<?php echo $this->get_field_id('show_continue'); ?>" name="<?php echo $this->get_field_name('show_continue'); ?>">
			Show Read More Button
        </label>
	</p>
    <p>
		<label for="<?php echo $this->get_field_id('read_more'); ?>"><?php _e("Custom Read More Text", "ocmx"); ?><input class="widefat" id="<?php echo $this->get_field_id('read_more'); ?>" name="<?php echo $this->get_field_name('read_more'); ?>" type="text" value="<?php if(isset($read_more)) echo $read_more; ?>" /></label>
	</p>
<?php 
	} // form

}// class

//This sample widget can then be registered in the widgets_init hook:

// register FooWidget widget
add_action('widgets_init', create_function('', 'return register_widget("feature_posts_widget");'));

?>